package fantasy;
/*
Copyright (C) 2015 Johan Ceuppens 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import javax.swing.ImageIcon;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import java.util.*;

class ElfGreen extends TownsFolk 
{
private StateTextLibrary textlib = new StateTextLibrary();
private StateTextLibrary asktextlib = new StateTextLibrary();
private StateTextLibrary itemtextlib = new StateTextLibrary();
private StateTextLibrary learntextlib = new StateTextLibrary();
private StateTextLibrary learnedanotherwordtextlib = new StateTextLibrary();

private StateTextLibrary learnvarlib = new StateTextLibrary();



public ElfGreen(int startx, int starty, String language)
{
	super(startx,starty);

	direction = "down";

	addDownImage("elfgreen-48x48-1.png");

	if (language == "Dutch" || language == "dutch") {

		textlib.addText("Er is onrust in het Oosten..");
		textlib.addText("een oud kwaad is aan het herrijzen..");
		//set to "-1" for not popping up the learn widget
		learnvarlib.addText("-1");
		learnvarlib.addText("-1");

		asktextlib.addText("Aangenaam.");
		itemtextlib.addText("Hopelijk heb je het niet nodig.");
		learntextlib.addText("Mime is dit mensen dorpje.");
		learnedanotherwordtextlib.addText("Onze mensen dansen en zingen graag.");
	} else if (language == "English" || language == "english") {

		textlib.addText("There is trouble in the east..");
		textlib.addText("an old evil stirs again..");
		learnvarlib.addText("-1");
		learnvarlib.addText("-1");

		asktextlib.addText("Pleased to meet you.");
		itemtextlib.addText("I hope you will not need it.");
		learntextlib.addText("Mime is this town, founded by men.");
		learnedanotherwordtextlib.addText("Our people love to dance and sing.");
	} else {

		textlib.addText("There is trouble in the east..");
		textlib.addText("an old evil stirs again..");
		learnvarlib.addText("-1");
		learnvarlib.addText("-1");

		asktextlib.addText("Pleased to meet you.");
		itemtextlib.addText("I hope you will not need it.");
		learntextlib.addText("Mime is this town, founded by men.");
		learnedanotherwordtextlib.addText("We love to dance and sing.");
	}
}

public String talkto()
{
	return textlib.getText();
}

public int learn()
{
	String s = learnvarlib.getText();

	int i = Integer.parseInt(s);
	return i;
}

//must be called after currentlearn > 0 in fantasy/Game.java
public void erasecurrent(int currentlearn) 
{
	//int idx = learnvarlib.getindex() - 1;
	//learnvarlib.setText(idx, "-1");//remove learn index feature
	learnvarlib.setText(currentlearn, "-1");//remove learn index feature
}

public String asktalkto()
{
	return asktextlib.getText();
}

public String asktalkto(int index)
{
	return asktextlib.getText(index);
}

public String itemtalkto()
{
	return itemtextlib.getText();
}

public String itemtalkto(int index)
{
	return itemtextlib.getText(index);
}

public String learntalkto()
{
	return learntextlib.getText();
}

public String learntalkto(int index)
{
	return learntextlib.getText(index);
}

public String learnedanotherwordtalkto()
{
	return learnedanotherwordtextlib.getText();
}

public String learnedanotherwordtalkto(int index)
{
	return learnedanotherwordtextlib.getText(index);
}

public int talktomaxindex()
{
	return textlib.getmax();
}

public int asktalktomaxindex()
{
	return asktextlib.getmax();
}

public int itemtalktomaxindex()
{
	return itemtextlib.getmax();
}

public int learntalktomaxindex()
{
	return learntextlib.getmax();
}

public int learnedanotherwordtalktomaxindex()
{
	return learnedanotherwordtextlib.getmax();
}

};

